// 
// このコードは、https://demo.mescius.jp/diodocs/pdf のサンプルの一部として提供されています。
// © MESCIUS inc. All rights reserved.
// 
using System;
using System.IO;
using System.Drawing;
using System.Text;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Text;
using GrapeCity.Documents.Drawing;
using System.Linq;

namespace DsPdfWeb.Demos
{
    // このデモでは、GcPdfDocument.RemoveImages() メソッドを使用して、
    // 特定のアスペクト比（正方形）の画像をPDFから削除する方法を紹介しています。
    public class RemoveSquareImages
    {
        public int CreatePDF(Stream stream)
        {
            using var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "SlidePages.pdf"));
            var doc= new GcPdfDocument();
            doc.Load(fs);
            // PDF内の画像リストを取得します。
            var imageInfos = doc.GetImages();
            // 正方形以外の画像をリストから削除します。(正方形の画像リストにする)
            for (int i = imageInfos.Count - 1; i >= 0; i--)
            {
                if (imageInfos[i].Image.Width != imageInfos[i].Image.Height)
                    imageInfos.RemoveAt(i);
            }
            // 正方形の画像を削除します。
            doc.RemoveImages(imageInfos);
            // PDF ドキュメントを保存します。
            doc.Save(stream);
            return doc.Pages.Count;
        }
    }
}
